ToitKoju/Models/Detail.cs
using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using System.Web.Mvc;

namespace ToitKoju.Models
{
    public class Detail
    {
        public int RecipeID { get; set; }
        public string IngredientName { get; set; }


        public virtual ICollection<Ingredient> Ingredients { get; set; }

        public Detail()
        {
            Ingredients = new HashSet<Ingredient>();
        }
    }

}

ToitKoju/Controllers/DetailsController.cs
using System;
using System.Collections.Generic;
using System.Data;
using System.Data.Entity;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using ToitKoju;


namespace ToitKoju
{
    public partial class Detail
    {
        public string IngredientName { get; set; }
    }
}

namespace ToitKoju.Controllers
{
    public class DetailsController : Controller
    {
        private ToitKojuEntities db = new ToitKojuEntities();

        // GET: Details
        public ActionResult Index()
        {
            var details = db.Details.Include(d => d.Ingredient).Include(d => d.Recipy);
            var unit = db.Ingredients.Select(x => x.Unit);
            ViewBag.CurrentUnit = unit;
            
            return View(details.ToList());
        }

        // GET: Details/Details/5
        public ActionResult Details(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Detail detail = db.Details.Find(id);
            if (detail == null)
            {
                return HttpNotFound();
            }
           

            return View(detail);
        }

        // GET: Details/Create
        public ActionResult Create()
        {
            ViewBag.IngredientID = new SelectList(db.Ingredients, "IngredientID", "IngredientName");
            ViewBag.RecipeID = new SelectList(db.Recipies, "RecipeID", "RecipeName");
            return View();
        }

        // POST: Details/Create
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Create([Bind(Include = "DetailID,RecipeID,OrderNo,IngredientID,Comment,Unit,UnitsAmount")] Detail detail)
        {
            if (ModelState.IsValid)
            {
                db.Details.Add(detail);
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            //else if (ModelState.IsValid)
            //{
            //    db.Details.Add(detail);
            //    db.SaveChanges();
            //    return RedirectToAction("Index");
            //}

            ViewBag.IngredientID = new SelectList(db.Ingredients, "IngredientID", "IngredientName", detail.IngredientID);
            ViewBag.RecipeID = new SelectList(db.Recipies, "RecipeID", "RecipeName", detail.RecipeID);
            return View(detail);
        }

        // GET: Details/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Detail detail = db.Details.Find(id);
            if (detail == null)
            {
                return HttpNotFound();
            }
            ViewBag.IngredientID = new SelectList(db.Ingredients, "IngredientID", "IngredientName", detail.IngredientID);
            ViewBag.RecipeID = new SelectList(db.Recipies, "RecipeID", "RecipeName", detail.RecipeID);
            return View(detail);
        }

        // POST: Details/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "DetailID,RecipeID,OrderNo,IngredientID,Comment,Unit,UnitsAmount")] Detail detail)
        {
            if (ModelState.IsValid)
            {
                db.Entry(detail).State = EntityState.Modified;
                db.SaveChanges();
                return RedirectToAction("Index");
            }
            ViewBag.IngredientID = new SelectList(db.Ingredients, "IngredientID", "IngredientName", detail.IngredientID);
            ViewBag.RecipeID = new SelectList(db.Recipies, "RecipeID", "RecipeName", detail.RecipeID);
            return View(detail);
        }

        // GET: Details/Delete/5
        public ActionResult Delete(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Detail detail = db.Details.Find(id);
            if (detail == null)
            {
                return HttpNotFound();
            }
            return View(detail);
        }

        // POST: Details/Delete/5
        [HttpPost, ActionName("Delete")]
        [ValidateAntiForgeryToken]
        public ActionResult DeleteConfirmed(int id)
        {
            Detail detail = db.Details.Find(id);
            db.Details.Remove(detail);
            db.SaveChanges();
            return RedirectToAction("Index");
        }

        protected override void Dispose(bool disposing)
        {
            if (disposing)
            {
                db.Dispose();
            }
            base.Dispose(disposing);
        }

     

    }
}

ToitKoju/Controllers/ShopController.cs
using System;
using System.Collections.Generic;
using System.Data.Entity;
using System.IO;
using System.Linq;
using System.Net;
using System.Web;
using System.Web.Mvc;
using ToitKoju.Models;

namespace ToitKoju.Controllers
{
    public class ShopController : Controller

    {



        private ToitKojuEntities shopDB = new ToitKojuEntities();
        //kategooria pildi lisamine
        public ActionResult CategoryImage(int? id) => CategorieImage(id);
        public ActionResult CategorieImage(int? id)
        {
            if (id == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            Category c = shopDB.Categories.Find(id.Value);
            if (c == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            if (c.Picture?.Length == null) return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            var picture = c.Picture.ToArray(); //tüüp on pildil byte array, loetakse terve pilt
            if (picture[0] == 21) picture = picture.Skip(78).ToArray(); //selle võib ära unustada
            return File(picture, "image/jpg");
        }


        //
        // GET: kategooriate nimekiri
        public ActionResult Index()
        {
            var category = shopDB.Categories.ToList();
            return View(category);
        }

        //
        // GET: /Shop/Browse
        public ActionResult Browse(string category)
        {
            var ostukorv = (Dictionary<int, Cart>)System.Web.HttpContext.Current.Session["ostukorv"];
            ViewBag.Ostukorv = ostukorv;
            //Kuvab kategooria seotuse retseptiga
            //var categoryModel = shopDB.Categories.Include("Recipies")
            //    .Single(g=>g.CategoryName==category);
            var c = shopDB.Categories.Where(x => x.CategoryName == category).SingleOrDefault();
            if (c == null) return new HttpStatusCodeResult(HttpStatusCode.ServiceUnavailable);
            return View(c);
        }

        //
        // GET: /Shop/Details/5
        public ActionResult Details(int id)
        {
            var recipy = shopDB.Recipies.Find(id);
            return View(recipy);
        }
        // GET: Shop/Edit/5
        public ActionResult Edit(int? id)
        {
            if (id == null)
            {
                return new HttpStatusCodeResult(HttpStatusCode.BadRequest);
            }
            Category category = shopDB.Categories.Find(id);
            if (category == null)
            {
                return HttpNotFound();
            }
            return View(category);
        }

        // POST: Shop/Edit/5
        // To protect from overposting attacks, please enable the specific properties you want to bind to, for 
        // more details see https://go.microsoft.com/fwlink/?LinkId=317598.
        [HttpPost]
        [ValidateAntiForgeryToken]
        public ActionResult Edit([Bind(Include = "CategoryID,CategoryName,Description,Picture")] Category category, HttpPostedFileBase file)
        {
            if (ModelState.IsValid)
            {
                shopDB.Entry(category).State = EntityState.Modified;
                shopDB.Entry(category).Property(x => x.Picture).IsModified = false; //kas fail on olemas?
                if (file != null && file.ContentLength > 0)
                {
                    using (BinaryReader br = new BinaryReader(file.InputStream)) //teeb streamreaderi, vormi input võetakse faili sisuks
                    {
                        byte[] buff = br.ReadBytes(file.ContentLength);
                        category.Picture = buff; //võta pildi väärtuseks puhver
                    }
                }

                shopDB.SaveChanges();
                return RedirectToAction("Index");
            }
            return View(category);
        }

        public ActionResult AddCart(int? id)
        {
            var ostukorv = (Dictionary<int, Cart>)System.Web.HttpContext.Current.Session["ostukorv"];
            var retsept = shopDB.Recipies.Find(id.Value);
            Cart c = ostukorv.Where(x => x.Value.RecipeID == id.Value).Select(x => x.Value).SingleOrDefault();
            if (c == null)
            {
                int nr = ostukorv.Keys.DefaultIfEmpty().Max() + 1;
                ostukorv[nr] = new Cart { RecipeID = id.Value, UnitsAmount = 1, RecipeName =  retsept.RecipeName};
            }
            else c.UnitsAmount++;
            ViewBag.Ostukorv = ostukorv;
            //var Retseptid = shopDB.Recipies.ToDictionary(x => x.RecipeID, x => x);
            //ViewBag.Ostukorv2 = ostukorv.Select(x => new { x.Key, x.Value.RecipeID, x.Value.UnitsAmount, ReceiptName = Retseptid[x.Value.RecipeID].RecipeName });
            return View("Browse", shopDB.Recipies.Find(id.Value).Category); // new { category = shopDB.Recipies.Find(id.Value).Category.CategorieName });
        }

        public ActionResult RemoveCart(int? id)
        {
            var ostukorv = (Dictionary<int, Cart>)System.Web.HttpContext.Current.Session["ostukorv"];
            Cart c = ostukorv[id.Value];
            Category t = shopDB.Recipies.Find(c.RecipeID).Category;
            if (c.UnitsAmount <= 1) ostukorv.Remove(id.Value);
            else c.UnitsAmount--;
            ViewBag.Ostukorv = ostukorv;
            return View("Browse", t); // new { category = shopDB.Recipies.Find(id.Value).Category.CategorieName });
        }


        public ActionResult ConfirmCart()
        {
            var ostukorv = (Dictionary<int, Cart>)System.Web.HttpContext.Current.Session["ostukorv"];
            foreach(var cart in ostukorv.Values)
            {
                shopDB.Orders.Add(new Order { OrderDate = DateTime.Now, DeliveryDate = DateTime.Now.AddDays(2), ActualEaters = cart.UnitsAmount, ReceipeID = cart.RecipeID, UserID = ToitKoju.User.GetByEmail(User.Identity.Name).UserID });
                shopDB.SaveChanges();
            }

            return RedirectToAction("Index", "Orders");
        }

        //[HttpPost]
        //[ValidateAntiForgeryToken]
        //public ActionResult Tellimus([Bind(Include = "OrderID,OrderDate,DeliveryDate,UserID,ReceipeID,ActualEaters,DeliveryInstructions")] Order order)
        //{
        //    var ostukorv = (Dictionary<int, Cart>)System.Web.HttpContext.Current.Session["ostukorv"];
        //    var orders = shopDB.Orders.Include(o => o.Recipy).Include(o => o.User);
        //    foreach (KeyValuePair<int, Cart> x in ViewBag.Ostukorv)
        //    {
        //        DateTime OrderDate = new DateTime(05 / 06 / 2018);
        //        DateTime DeliveryDate = new DateTime(05 / 06 / 2018);
        //        int UserID = x.Value.UserID;
        //        int RecipeID = x.Value.RecipeID;
        //        int ActualEaters = x.Value.UnitsAmount;

        //        if (ModelState.IsValid)
        //        {
        //            shopDB.Orders.Add(order);
        //            shopDB.SaveChanges();
        //        }

        //    }
        //    return View("Orders");
        //}

    }
}

ToitKoju/Views/Shop/Browse.cshtml
@using T = ToitKoju;
@model ToitKoju.Category

@{
    ViewBag.Title = "Browse";
}
<div>
    <h2>Toitude nimekiri: @Model.CategoryName</h2>
    <table>
        @foreach (var recipies in Model.Recipies)
        {
            <tr>
                <td>
                    @*@recipies.RecipeName*@
                    @* TODO: Vaata üle. Peaks kuvama retsepti kirjelduse *@
                    @*@Html.ActionLink(recipies.RecipeName,
                        "Details", "Recipies", new { id = recipies.RecipeID }, null)*@
                </td>
                <td>
                    @*<img src='@Url.Action( "RecipyImage", "Recipies", new { id = recipies.RecipeID } )' width="200" height="200">*@
                </td>

                @* Pilt lingina, all tekst *@
                <div class="col-md-3 portfolio-item">
                    <a href='@Url.Action( "Details", "Recipies", new { id = recipies.RecipeID } )'>
                        <img src='@Url.Action( "RecipyImage", "Recipies", new { id = recipies.RecipeID } )' class="img-circle" alt="Cinque Terre" width="250" height="250">
                    </a>

                    @*<h3 class="text-center">
                                        @Html.ActionLink(recipies.RecipeName,
                        "AddCart", new { id = recipies.RecipeID }, null)
                                </h3>*@
                    <h3 class="text-center">
                        <button type="button" class="btn btn-default btn-lg">
                            <span class="glyphicon glyphicon-shopping-cart"></span> @Html.ActionLink(recipies.RecipeName,
"AddCart", new { id = recipies.RecipeID }, null)
                        </button>
                    </h3>
                </div>
            </tr>
        }
    </table>
</div>

@*@using (Html.BeginForm())
    {
        @Html.AntiForgeryToken()*@

@*<div class="form-horizontal">
    <h4>Category</h4>
    <hr />
    @Html.ValidationSummary(true, "", new { @class = "text-danger" })*@
@*<div class="form-group">
        @Html.LabelFor(model => model.CategoryName, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.CategoryName, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.CategoryName, "", new { @class = "text-danger" })
        </div>
    </div>*@

@*<div class="form-group">
        @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
        <div class="col-md-10">
            @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
            @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
        </div>
    </div>*@

@*<div class="form-group">
        <div class="col-md-offset-2 col-md-10">
            <input type="submit" value="Loo uus" class="btn btn-default" />
        </div>
    </div>*@
@*</div>
    }*@


<div>
    <h3>Ostukorvis on:</h3>
    @foreach (KeyValuePair<int, ToitKoju.Models.Cart> x in ViewBag.Ostukorv)
    {
        <p> @x.Value.RecipeName (@x.Value.UnitsAmount) @Html.ActionLink("eemalda", "RemoveCart", new { id = x.Key })</p>
    }

    @if (Request.IsAuthenticated)
    {
        T.User u = T.User.GetByEmail(User.Identity.Name);
        if (u != null)
        {
            <td> @Html.ActionLink("Telli", "ConfirmCart")</td>

        }
    }
    else
    {<td>@Html.ActionLink("Telli", "Login", "Account")</td>}
</div>

<div>
    @Html.ActionLink("Back to List", "Index")
</div>
<table>
    <tr>
        @section Scripts {
            @Scripts.Render("~/bundles/jqueryval")
        }
    </tr>
</table>

ToitKoju/Views/Shop/Details.cshtml
@model ToitKoju.Recipy

@{
    ViewBag.Title = "Details";
}

<h2>Tooted: @Model.CategoryID</h2>


@using (Html.BeginForm()) 
{
    @Html.AntiForgeryToken()
    
    <div class="form-horizontal">
        <h4>Recipy</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        <div class="form-group">
            @Html.LabelFor(model => model.RecipeID, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.RecipeID, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.RecipeID, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.RecipeName, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.RecipeName, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.RecipeName, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.CategoryID, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.CategoryID, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.CategoryID, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Author, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Author, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Author, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.TargetAmount, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.TargetAmount, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.TargetAmount, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Instructions, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Instructions, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Instructions, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Create" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}

ToitKoju/Views/Shop/Edit.cshtml
@model ToitKoju.Category

@{
    ViewBag.Title = "Edit";
}

<h2>Edit</h2>


@using (Html.BeginForm(
    "Edit",
    "Shop",
    FormMethod.Post,
    new { enctype = "multipart/form-data" }))
{
    @Html.AntiForgeryToken()

    <div class="form-horizontal">
        <h4>Category</h4>
        <hr />
        @Html.ValidationSummary(true, "", new { @class = "text-danger" })
        @Html.HiddenFor(model => model.CategoryID)

        <div class="form-group">
            @Html.LabelFor(model => model.CategoryName, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.CategoryName, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.CategoryName, "", new { @class = "text-danger" })
            </div>
        </div>

        <div class="form-group">
            @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
            <div class="col-md-10">
                @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
                @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
            </div>
        </div>

        @*<div class="form-group">
                @Html.LabelFor(model => model.Picture, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">
                    @Html.EditorFor(model => model.Picture, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.Picture, "", new { @class = "text-danger" })
                </div>
            </div>*@
        @*// eelnev lihtsamalt nii input type file, ID file*@
        <img id="pilt" src='@Url.Action( "CategoryImage", "Shop", new { id = Model.CategoryID } )' height="80" />
        <label for="file">Upload Image:</label>
        <input type="file" name="file" id="file" /><br><br> @*//post meetod tunneb faili järgi ära*@


        <div class="form-group">
            <div class="col-md-offset-2 col-md-10">
                <input type="submit" value="Save" class="btn btn-default" />
            </div>
        </div>
    </div>
}

<div>
    @Html.ActionLink("Back to List", "Index")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}
<script src="https://code.jquery.com/jquery-3.2.1.slim.min.js" integrity="sha384-KJ3o2DKtIkvYIK3UENzmM7KCkRr/rE9/Qpg6aAZGJwFDMVNA/GpGFF93hXpG5KkN" crossorigin="anonymous"></script>

<script>
    function readURL(input) {
        if (input.files && input.files[0]) {
            var reader = new FileReader();

            reader.onload = function (e) {
                $('#file').attr('src', e.target.result);
            }
            reader.readAsDataURL(input.files[0]);
        }
    }
    $(document).ready(function () {
        $("#file").change(function () {
            readURL(this);
        });
    });

</script>

ToitKoju/Views/Shop/Index.cshtml
@using T = ToitKoju;
@model IEnumerable<ToitKoju.Category>

@{
    ViewBag.Title = "Shop";
}

<h2>Toidud</h2>

@if (Request.IsAuthenticated)
{
    T.User u = T.User.GetByEmail(User.Identity.Name);
    if (u != null && u.IsInRoleAdmin)
    {
        @Html.ActionLink("Create New", "Create", "Recipies")
    }
}
<p>
    Select from @Model.Count()
    category:

</p>


<table>

    <ul>
        @foreach (var category in Model)
        {
        <tr>
            <td>
                <p>@Html.ActionLink(category.CategoryName, "Browse", new { category = category.CategoryName }) </p>
            </td>
            
            <td><img src='@Url.Action( "CategoryImage", "Shop", new { id = category.CategoryID } )' class="img-rounded" alt="Cinque Terre" width="200" height="200" /></td>

            @if (Request.IsAuthenticated)
    {
        T.User u = T.User.GetByEmail(User.Identity.Name);
        if (u != null && u.IsInRoleAdmin)
        {
            <td> @Html.ActionLink("Edit", "Edit", new { id = category.CategoryID })</td>

}
}
        </tr>
        }
    </ul>

</table>




@*@using (Html.BeginForm())
    {
        @Html.AntiForgeryToken()

        <div class="form-horizontal">
            <h4>Category</h4>
            <hr />
            @Html.ValidationSummary(true, "", new { @class = "text-danger" })
            <div class="form-group">
                @Html.LabelFor(model => model.CategoryName, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">
                    @Html.EditorFor(model => model.CategoryName, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.CategoryName, "", new { @class = "text-danger" })
                </div>
            </div>

            <div class="form-group">
                @Html.LabelFor(model => model.Description, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">
                    @Html.EditorFor(model => model.Description, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.Description, "", new { @class = "text-danger" })
                </div>
            </div>

            <div class="form-group">
                @Html.LabelFor(model => model.Picture, htmlAttributes: new { @class = "control-label col-md-2" })
                <div class="col-md-10">
                    @Html.EditorFor(model => model.Picture, new { htmlAttributes = new { @class = "form-control" } })
                    @Html.ValidationMessageFor(model => model.Picture, "", new { @class = "text-danger" })
                </div>
            </div>

            <div class="form-group">
                <div class="col-md-offset-2 col-md-10">
                    <input type="submit" value="Create" class="btn btn-default" />
                </div>
            </div>
        </div>*@
@*}*@

<div>
    @Html.ActionLink("Avalehele", "Index", "Home")
</div>

@section Scripts {
    @Scripts.Render("~/bundles/jqueryval")
}